/* cc -Wall -g -pedantic XRandRfl.cxx -o XRandRfl -lX11 `pkg-config --libs xrandr` */
#include <X11/extensions/Xrandr.h>
#include <stdio.h>

int main(int argc, char ** argv)
{
  Display * display = XOpenDisplay(":0.0");
  int screen = DefaultScreen( display );
  Window w = RootWindow(display, screen);
  XRRScreenResources * res = XRRGetScreenResources(display, w);
  for(int i=0; i < res->noutput; ++i)
  {
    XRROutputInfo * output_info = XRRGetOutputInfo( display, res, res->outputs[i]);
    if(output_info->crtc)
    {
      XRRCrtcInfo * crtc_info = XRRGetCrtcInfo( display, res,
                                                output_info->crtc );
      unsigned int pixel_width = crtc_info->width,
                   pixel_height = crtc_info->height;
      float xdpi = pixel_width * 25.4f / (float)output_info->mm_width,
            ydpi = pixel_height * 25.4f / (float)output_info->mm_height;
      printf( "[%d] %upx x %upx  Dimensions: %limm x %limm  DPI: %.02f x %.02f\n",
              i, pixel_width, pixel_height,
              output_info->mm_width, output_info->mm_height,
              xdpi, ydpi );
    }
    XRRFreeOutputInfo( output_info );
  }
  XRRFreeScreenResources(res);
  XCloseDisplay( display );
  return 0;
}
